from typing import Any

from fastapi.encoders import jsonable_encoder

from app.common import const


class ApiResult:

    def __init__(self, code, message, data) -> None:
        self.code = code
        self.message = message
        self.data = data

    code: int
    message: str
    data: Any

    @staticmethod
    def success():
        return jsonable_encoder(ApiResult(const.SUCCESS, const.SUCCESS_MSG, data=None))

    @staticmethod
    def success_msg(message: str):
        return jsonable_encoder(ApiResult(const.SUCCESS, message, data=None))

    @staticmethod
    def success_data(data):
        return jsonable_encoder(ApiResult(const.SUCCESS, const.SUCCESS_MSG, data))

    @staticmethod
    def success_str_data(message: str, data):
        return jsonable_encoder(ApiResult(const.SUCCESS, message, data))

    @staticmethod
    def error():
        return jsonable_encoder(ApiResult(const.ERROR, const.ERROR, data=None))

    @staticmethod
    def error_msg(message: str):
        return jsonable_encoder(ApiResult(const.ERROR, message, data=None))

    @staticmethod
    def error_data(data):
        return jsonable_encoder(ApiResult(const.ERROR, const.ERROR, data))

    @staticmethod
    def error_str_data(message: str, data):
        return jsonable_encoder(ApiResult(const.ERROR, message, data))
